
;======================== DATA MANIPULATION ============================
datawriter ;note/hexvalue typing, hexvalue in X
        lda shiftsig
        ora cbmsig
        bne retdatw
        stx wrhxad1+1
        stx wrhxad3+1
        lda fulljam
        beq +
        lda jammode
        beq +
.if (HERMIDI_SUPPORT>0)
;        lda HerMIDIswitch
;        beq dofullj
        lda #0
        sta MIDIsig+1 ;don't clash with running MIDI-sound
.fi
dofullj lda NoteOfX,x
        sta jamnote+1
        jmp jammer 
+       ldx currwin
        ;cmp #ptnwin
        bne chdwoli
dwpattn jsr getcurptnaddr
        sta astore1+1
astore1 cpy #selfmod ;outside of pattern?
        bcs retdatw
        ldx curwinposx+ptnwin
        lda trksubpos,x
        beq cnotefx ;notewhx ;note-column?
        jsr repeatex
        ldx curwinposx+ptnwin
        lda trkdiginum,x
        tax
puthexv lda (idatzp),y
        jsr writehex
        sta (idatzp),y
retdatw rts

chdwoli cpx #oliwin
        bne chdwins
dwordli jsr repeatex
        jsr getcurseqaddr
        lda curwinposx+oliwin
        and #1
        tax
        jmp puthexv
        

chdwins cpx #inswin
        bne retdatw
dwinstb jsr getcurinstbaddr
        lda curwinposx+inswin
        ldx notemode
        beq wrinshx
        cmp #2 ;freq-column?
        beq notewhx ;bne +
        ;ldx wrhxad1+1 ;below $80
        ;cpx #$08
        ;bpl notewhx ;freq-column?
+       cmp #3  
        beq notewhx ;freq-column?
wrinshx jsr repeatex
        lda curwinposx+inswin
        and #1
        tax
        jmp puthexv

cnotefx lda (idatzp),y
        bpl notewhx
        ldx wrhxad1+1
        bne + ;0 value deletes the FX
        jsr repeatex
        lda #0
        sta (idatzp),y
        rts
+       jsr repeatex
        ldx #1
        jmp puthexv

notewhx ldx wrhxad1+1
        lda NoteOfX,x
notewh2 cmp #$ff
        beq jamorw ;wrinshx ;retdatw
        sta jamnote+1
        lda jammode
        bne jamorw
        jsr repeatex
        lda jamnote+1
        bne wrinote
        jmp writeno ;1 and A keys delete content at cursor-position

jamorw  lda currwin
        cmp #inswin
        beq wrinshx
.if (HERMIDI_SUPPORT>0)
        ;lda HerMIDIswitch
        ;beq +
        lda #0
        sta MIDIsig+1 ;don't clash with running MIDI-sound
.fi
+       jmp jammer


notewriter ;note-value in X
.if (HERMIDI_SUPPORT>0)
        ;lda HerMIDIswitch
        ;beq +
        lda #0
        sta MIDIsig+1 ;don't clash with running MIDI-sound
.fi
+       lda shiftsig
        bne retnotew
        lda cbmsig
        bne retnotew
notewr2 stx jamnote+1
        lda jammode 
        beq +
        jmp jammer
+       jsr repeatex
        lda currwin
        ;cmp #ptnwin
        beq wriptno
        cmp #inswin
        bne jammer ;retnotew
wriinot jsr getcurinstbaddr
        ldx curwinposx+inswin
        cpx #2 ;freq-column?
        beq wrinote
        cpx #3 ;freq-column?
        beq wrinote
        jmp jammer
retnotew rts
wriptno jsr getcurptnaddr
        sta astore2+1
astore2 cpy #selfmod ;outside of pattern?
        bcs retnotew
        ldx curwinposx+ptnwin
        lda trksubpos,x
        ;cmp #pnotesubpos
        bne jammer ;retnotew ;don't write note in ins/fx column
wrinote lda jamnote+1 ;Y holds position in track here! don't touch
        cmp #maxnotenum ;note-column-fx?
        bcc +
        ldx #0
        stx jamnote+1
        jmp writeno
+       jsr wrinot2
        jmp jammer

wrinot2 
.if (HERMIDI_SUPPORT>0)
        ldx HerMIDIswitch
        beq +
        ldx MIDIsig+1
        beq +
        txa
        bne ++
.fi
+       clc
        ldx octave
        adc OCTMULS,x
+       cmp #maxnotenum
        bcs retnotew
        ldx currwin
        cpx #inswin
        bne writeno
        ldx notemode
        beq retnotew
+       ora #$80 ;absolute-notes in instrument-table 'frequency' column
writeno sta (idatzp),y
        lda (idatzp),y
        bpl + ;don't advance for note-fx in pattern-window
        lda currwin
        ;cmp #ptnwin
        beq jammer ;retnotew
+       lda advance
        beq jammer ;retnotew
        iny
        cpy astore2+1
        beq retnotew
        jmp crsrdn ;jmp crsrdn ;advance in pattern

jammer  lda playmode
        bne retnotew
        ldx #1       ;display realtime play-positions in instr.tables
        lda currwin
        ;cmp #ptnwin
        bne + ;if not pattern-window, always display channel2 instr.
        ldy curwinposx+ptnwin ;else display instr. of cursor's channel
        ldx trkselect,y
+       lda jamnote+1
prvnote cmp #selfmod
        beq retnotew
.if (HERMIDI_SUPPORT>0)
        ldy HerMIDIswitch
        beq +
        ldy MIDIsig+1
        beq +
        tya
        bne ++
.fi
+       clc
        ldy octave
        adc OCTMULS,y
+       .if (SEQ_FX_SUPPORT!=0 && TRANSPOSE_SUPPORT!=0)
         adc player.transpose,x
        .fi
        sta player.currnote,x
        lda currins
        sta player.currinst,x
        tay
        lda insptlo,y
        sta playzp_default+0
        lda inspthi,y
        sta playzp_default+1
        lda prvnote+1
        bne legato ;there was no gap between keypresses? -> legato
newnote ;lda #cmd_rts
        ;sta player.return0
.if (SYNC_SUPPORT!=0 || PHASE_SUPPORT!=0)
        lda #0
        sta player.syncmode+0
        sta player.syncmode+1
.fi
        jmp player.initins ;jsr player.initins ;(this editor's version ends with 'rts' after instrument initializations)
        ;jmp bktonop
legato  ;lda #cmd_rts
        ;sta player.return0
        jmp player.legato ;jsr player.legato
;bktonop lda #cmd_nop
;        sta player.return0
;        rts


writehex ;inputs: read-value in A, digi-number in X, Y is intact 
        cpx #1
		beq writehex2
;merge typed 1st hexa digit with existing data
writehex1
		and #$0f
		sta wrhxad2+1
wrhxad1 lda #selfmod	
		asl
		asl
		asl
		asl
wrhxad2 ora #selfmod
        ldx currwin
		inc curwinposx,x
		rts
writehex2			;merge typed 2nd hexa digit with existing data
		and #$f0
wrhxad3 ora #selfmod
		rts


getcurptnaddr ;into idatzp, returns current index in Y, current track in X, current patternlength in A
        jsr getcurtrk
        lda trksubpos,x
        tax
getptna ldy trkstor+1
        lda currptn,y ;entry point to give column inside track in X (call getcurtrk beforehand)
        tay
        lda pattptlo,y
        clc
        adc ptcolindexes,x
        sta idatzp+0
        lda pattpthi,y
        adc #0 ;add Carry
        sta idatzp+1
        lda ptnlen,y
        sta ptlenst+1
trkstor ldx #selfmod
gettidx lda curwinposy+ptnwin
        clc
        adc ptnindex,x
        tay
ptlenst lda #selfmod
        rts

getcurtrk ldx curwinposx+ptnwin
        ldy trkselect,x
        sty trkstor+1
        rts


getcurseqaddr
.if (HORIZONTAL_ORDERLIST>0)
        lda curwinposy+oliwin
.else
        ldy curwinposx+oliwin
        lda oliindex,y
.fi
getseqa sta olichan+1
        ldy cursubtune
        lda seqptrlo,y
        sta idatzp+0
        lda seqptrhi,y
        sta idatzp+1
olichan ldy #selfmod
        beq setseqy
-       lda idatzp+0
        clc
        adc #maxseqlen+1
        sta idatzp+0
        bcc +
        inc idatzp+1
+       dey
        bne -
setseqy 
.if (HORIZONTAL_ORDERLIST>0)
        lda curwinposx+oliwin
        lsr
.else
        lda curwinposy+oliwin
.fi
        clc
        adc seqindex
        tay
        rts


getcurinsaddr
        ldy currins
        lda insptlo,y
        sta idatzp+0
        lda inspthi,y
        sta idatzp+1
        lda curwinposx+inamewin
        clc
        adc #insnamepos
        tay
        rts


getcurinstbaddr
        ldx curwinposx+inswin
getitba ldy currins
        lda insptlo,y
        clc
        adc inswindex,x
        sta idatzp+0
        lda inspthi,y
        adc #0 ;add Carry
        sta idatzp+1
        lda curwinposy+inswin
        clc
        adc insindex
        tay
        rts


OCTMULS .byte 0,12,24,36,48,60,72,84,96,108 ;TRANSPOSITION VALUE OF OCTAVES TO ADD/SUBSTRACT FROM NOTE

NoteOfX	.byte 12+12+4	;X=0 D# in the second higher keyboard octave
		.byte 0			;X=1 no note to play, using for NOP placement
		.byte 12+2		;X=2 C# in the higher keyboard octave
		.byte 12+4		;X=3 D# in the higher keyboard octave
		.byte $ff		;X=4 no note for key 4
		.byte 12+7		;X=5 F# in the higher keyboard octave
		.byte 12+9		;X=6 G# in the higher keyboard octave
		.byte 12+11		;X=7 A# in the higher keyboard octave
		.byte $ff		;X=8 no note for key 8
		.byte 12+12+2	;X=9 C# in the second higher keyboard octave
		.byte 0			;X=A no note assigned for key A, using it for NOP
		.byte 0+8		;X=B G in the lower keyboard octave
		.byte 0+5		;X=C E in the lower keyboard octave
		.byte 0+4		;X=D D# in the higher keyboard octave
		.byte 12+5		;X=E E in the higher keyboard octave
		.byte $ff		;X=F no sound produced on F key for jamming


