;=============================== MENU ==================================
exitsig .byte 0 ;different return-levels , see 'exitmode_xxx' for values


.if (MENU_SUPPORT>0)

menux=(rowlen-menuwidth)/2
menuy=4
menuwidth=menutxt0_end-menutxt0
menuheight=(menutxt_end-menutxt)/menuwidth
menupoint .byte 0 ;current menupoint
menusize=menuheight-2


menu    lda #exitmode_noexit
        sta exitsig
menustrt;sei
        jsr ROMdisa
        ;jsr stopply
        jsr player.silence
        jsr dispmenu
        ;lda #keymode_menu
        ;sta keyermode ;set already by menu-caller
        jsr waitkeyrelease

menuloop 
        lda #$CD
        cmp vscanpos
        bne *-3
        jsr keyer
        jsr dispMenuPt
        lda keyermode
        cmp #keymode_menu
        beq menumod
        jmp backtoe ;chexits
menumod lda exitsig
        ;cmp #exitmode_noexit
        beq menuloop
        cmp #exitmode_justlaunch ;just back to menu?
        beq menu ;redraw menu after helptext-display
backtoe ;sei
        ;jsr ROMdisa
.if (HERMIDI_SUPPORT>0)
        lda HerMIDIswitch
        beq + ;was HerMIDI turned ON?
        lda #(MACHINE<2)? 16+HerMIDI.AsyncMode : HerMIDI.MaxBuffSize  ;synchronous mode (bit7=0)?, HerMIDI.MaxBuffSize: max. buffersize that's supported by HerMIDI
        jsr HerMIDI.PowerON ;Carry=0 on exit when succeeded (StatusByte can be checked later as well)
.fi
+       jmp chexits


menukeyer
 		cpy #$0F*2 ;Shift?
		bne +
shiftpr	jmp nextkey
+		cpy #$3F*2 ;STOP key?
		beq +
        cpy #(MACHINE<2)? $34*2:$39*2 ;ESC/back-arrow key?
        beq +
		cpy #$03*2 ;HELP(F8)/F7 key?
		bne chCurDn ;chHelp
        jsr repeatex ;prevents going back to editor instantly (was occasionall bug)
+		jmp retuEdi
;chHelp	lda helpmode
;		beq chCurDn
;		jmp HelpKeyHandler
chCurDn	cpy #(MACHINE<2)? $28*2:$07*2 ;cursor-down key?
		bne (MACHINE<2)? chCurUp:chCurRi
        .if (MACHINE>=2)
        lda shiftsig
        bne menucUp
        .fi
menucDn jsr repeatex
	    ldx menupoint
		inx
		cpx #menusize
		bne +
		ldx #0
+		stx menupoint
		rts
chCurUp .if (MACHINE<2)
        cpy #$2B*2 ;cursor-up key?
        bne chCurRi
        .fi
menucUp	jsr repeatex
        dec menupoint
		bpl +
		ldx #menusize-1
		stx menupoint
+		rts
chCurRi	cpy #(MACHINE<2)? $33*2:$02*2 ;cursor-right key?
		beq increas
		cpy #(MACHINE<2)? $36*2:$28*2 ;plus key?
		bne chMinus
increas	.if (MACHINE>=2)
        lda shiftsig
        bne decreas
        .fi
        ldy menupoint
		cpy #(drivePl-menutxt1)/menuwidth
		bne +
		jmp setDrive
+
 .if (PLAYABLE_EXPORT_SUPPORT>0)
 		cpy #(relocPl-menutxt1)/menuwidth
		bne +
		jmp incReloc
+ 		cpy #(zeropPl-menutxt1)/menuwidth
		bne +
		jmp incZeroP
+
 .fi
 .if (RUNNABLE_EXPORT_SUPPORT>0)
        cpy #(plytimtx-menutxt1)/menuwidth
        bne +
        jmp incPlayTime
+
 .fi
        cpy #(ptlenPl-menutxt1)/menuwidth
        bne retmkey
        jmp incDefPtLen
chMinus	cpy #(MACHINE<2)? $2E*2:$2B*2 ;Minus-key?
        .if (MACHINE<2)
		beq decreas
        cpy #$30*2 ;cursor-left key?
        .fi
        bne chRetur
decreas ldy menupoint
		cpy #(drivePl-menutxt1)/menuwidth
		bne +
		jmp decdevi
+
 .if (PLAYABLE_EXPORT_SUPPORT>0)
 		cpy #(relocPl-menutxt1)/menuwidth
		bne +
		jmp decReloc
+
 		cpy #(zeropPl-menutxt1)/menuwidth
		bne +
		jmp decZeroP
+
 .fi
 .if (RUNNABLE_EXPORT_SUPPORT>0)
        cpy #(plytimtx-menutxt1)/menuwidth
        bne +
        jmp decPlayTime
+
 .fi
        cpy #(ptlenPl-menutxt1)/menuwidth 
        bne retmkey
        jmp decDefPtLen
chRetur	cpy #$01*2 ;Return-key?
		bne chNumbr
goMenuP	lda menupoint
goMenP2 asl
		tax
		lda menuPtAddr,x
		sta menuJmp+1
		lda menuPtAddr+1,x
		sta menuJmp+2
menuJmp	jmp selfmodA ;self-written - jumping to menupoint
chNumbr	tya
		ldx #menusize+1 ;$0F-1 ;menusize-1
-		cmp menuPtKey,x
		bne ++
        cpx #menusize+1 ;$0F-1
        bcc +
        txa
        jmp goMenP2
+		stx menupoint
		jsr dispMenuPt
		jmp goMenuP
+		dex
		bpl -
retmkey	rts


setDrive jsr repeatex
		ldy devicen+1
		cpy #15	;max. device number
		iny
		blt setdevi
		ldy #8	;min. device-number
setdevi	sty devicen+1
dispdev lda devicen+1
		jsr decdisp
		sty drivetxt		;display device-number digit1 in menu
		sta drivetxt+1	;display device-number digit2 in menu
		rts
decdevi	jsr repeatex
		ldy devicen+1
		dey
		cpy #8-1
		bne +
		ldy #15
+		jmp setdevi


 .if (PLAYABLE_EXPORT_SUPPORT>0 )
  .if (RELOCATION_SUPPORT>0)
setReloc
incReloc lda repecnt		;keyrepeat-counter  --- trick to make it faster
		bne +			;check, if repeat counter is 0
		lda #1 ;alternative (faster) repeat-speed for relocation-setting
		sta repecnt		;if 0, reset counter to alternative repeatspeed
		rts 
+		jsr repeatex
		lda #>playersize ;lda #>tunedata_end ;end of area to be exported - hi-byte
		;sec 			;injected by tlr at CSDB
		;sbc #>PLAYERADDR;injected by tlr at CSDB - this checks if the tune fits into the remaining range below top of memory (RELOC_MAX_HI)
		clc
		;adc #1			;add 1 for safety to be in range
		adc relocaddr
		bcs wraprlU ;direloc		;if range passes over top of memory, don't allow further change
		cmp #reloc_hi_max ;max relocation-address - checked tunelength some rows above
		bne + ;beq direloc
wraprlU lda #reloc_hi_min ;min. reloc. address
        sta relocaddr
        jmp dispReloc
+	    inc relocaddr
        jmp dispReloc
decReloc lda repecnt		;keyrepeat-counter  --- trick to make it faster
		bne +			;check, if repeat counter is 0
		lda #1 ;alternative repeat-speed for relocation-setting
		sta repecnt		;if 0, reset counter to alternative repeatspeed
		rts 
+	 	jsr repeatex 
		lda relocaddr
		cmp #reloc_hi_min		;min. reloc. address
		bne + ;beq direloc
wraprlD lda #reloc_hi_max ;max reloc.addr.
        sec
        sbc #>playersize
        sta relocaddr
        jmp dispReloc
+   	dec relocaddr
;		jmp dispReloc

dispReloc
		lda relocaddr
        jsr hexdisp
        stx reloctxt+0
		sta reloctxt+1
		rts
  .fi
decZeroP
        jsr repeatex
        dec zeropaddr
        jmp dispZeroP
incZeroP
        jsr repeatex
        inc zeropaddr
dispZeroP
		lda zeropaddr
        jsr hexdisp
        stx zeroptxt+0
		sta zeroptxt+1
		rts

 .fi ;end of PLAYABLE_EXPORT_SUPPORT && RELOCATION_SUPPORT

.if (RUNNABLE_EXPORT_SUPPORT>0)
dispPlayTime
        lda tuneheader.playtime0+0 ;Minutes
        jsr hexdisp
        stx plytimtx+13
        sta plytimtx+14
        lda tuneheader.playtime0+1 ;Seconds
        jsr hexdisp
        stx plytimtx+16
        sta plytimtx+17
        rts

incPlayTime
        jsr repeatex
        sed
        lda tuneheader.playtime0+1 ;Seconds
        clc
        adc #1
        cmp #$60
        bcc ++
        lda tuneheader.playtime0+0 ;Minutes
        clc
        adc #1
        bcc +
        lda #$00
+       sta tuneheader.playtime0+0 ;Minutes
        lda #$00
+       sta tuneheader.playtime0+1 ;Seconds
        cld
        jmp dispPlayTime

decPlayTime
        jsr repeatex
        sed
        lda tuneheader.playtime0+1 ;Seconds
        sec
        sbc #1
        bcs ++
        lda tuneheader.playtime0+0 ;Minutes
        sec
        sbc #1
        bcs +
        lda #$99
+       sta tuneheader.playtime0+0 ;Minutes
        lda #$59
+       sta tuneheader.playtime0+1 ;Seconds
        cld
        jmp dispPlayTime
.fi

incDefPtLen
        jsr repeatex
        lda tuneheader.defaultptlen
        cmp #maxptnlen
        bcc + ;bcs +
        lda #1-1
        sta tuneheader.defaultptlen
+       inc tuneheader.defaultptlen
        jmp dispdefplen
decDefPtLen
        jsr repeatex
        lda tuneheader.defaultptlen
        cmp #2
        bcs + ;bcc +
        lda #maxptnlen+1
        sta tuneheader.defaultptlen
+       dec tuneheader.defaultptlen
        jsr dispdefplen
        rts

dispdefplen
        lda tuneheader.defaultptlen
        jsr hexdisp
        stx ptlentxt+0
        sta ptlentxt+1
        rts

 .if (HERMIDI_SUPPORT>0)
.enc screen
setMIDI jsr repeatex
        lda HerMIDIswitch
        eor #$FF
        sta HerMIDIswitch
        ldx #"-"
        ldy #"-"
        lda HerMIDIswitch
        beq +
        ldx #"O"
        ldy #"N"
+       stx midictxt+0
        sty midictxt+1
        rts
.enc none
 .fi


;--------------------------------------------
dispmenu lda #menubgcol
        sta bgcol
        sta bordcol
        jsr hidecursor
        lda #menuhelpcol
        jsr clearscrn
        lda #$1b+$40 ;extended-colour mode
        sta vmodeyscroll
        lda #menubarcol
        sta ECMinvcol
        jsr capitch
        jsr dispMenuPt
 .if (HELPTEXT_SUPPORT>0)
        ldy #rowlen-1
-       lda MenuHelpTxt,y
        sta VRAM+0*rowlen,y
        lda MenuHelpTxt+rowlen*3,y
        sta VRAM+1*rowlen,y
        lda MenuHelpTxt+rowlen,y
        sta VRAM+22*rowlen,y
        lda MenuHelpTxt+rowlen*2,y
        sta VRAM+23*rowlen,y
        lda CreditTxt,y
        sta VRAM+lastrow*rowlen,y
        dey
        bpl -
diplinf lda #PLAYERTYPE
        asl
        asl
        asl
        tax
        ldy #0
-       lda pltypetxt,y
        sta VRAM+(menuy-1)*rowlen+1,y
        lda playername,x
        sta VRAM+menuy*rowlen+2,y
        lda pltimetxt,y
        sta VRAM+(menuy-1)*rowlen+rowlen-9,y
        lda plsizetxt,y
        sta VRAM+menuy*rowlen+rowlen-9,y
        inx
        iny
        cpy #8
        bne -
        lda #>playersize
        jsr hexdisp
        sta VRAM+menuy*rowlen+rowlen-3
        lda #<playersize
        jsr hexdisp
        stx VRAM+menuy*rowlen+rowlen-2
        sta VRAM+menuy*rowlen+rowlen-1
        lda #rastertime
        jsr hexdisp
        stx VRAM+(menuy-1)*rowlen+rowlen-2
        sta VRAM+(menuy-1)*rowlen+rowlen-1
disfeat lda #<(VRAM+(menuy+2)*rowlen)
        ldx #>(VRAM+(menuy+2)*rowlen)
        sta diszp+0
        stx diszp+1
        ldx #0
        stx rowzp        
        stx featpos+1
-       ldy rowzp
        lda featinstances,y
featpos ldy #selfmod
        sta (diszp),y
        ldy #0
-       iny
        lda featuretxt,x
        and #$3F
        sta (diszp),y
        inx
        cpy #8
        bne -
        jsr nextrow
        inc rowzp
        ldy rowzp
        cpy #(featuretxt_end-featuretxt)/8/2
        bne +
        lda #<(VRAM+(menuy+2)*rowlen+rowlen-10)
        sta diszp+0
        lda #>(VRAM+(menuy+2)*rowlen+rowlen-10)
        sta diszp+1   
        lda #9
        sta featpos+1
+       cpy #(featuretxt_end-featuretxt)/8
        bne --     
 .fi
        
        jsr dispdev
 .if (PLAYABLE_EXPORT_SUPPORT>0)
		jsr dispReloc
        jsr dispZeroP
 .fi
 .if (RUNNABLE_EXPORT_SUPPORT>0)
        jsr dispPlayTime
 .fi
        jmp dispdefplen

dispMenuPt 
        ldx menupoint
        inx
        inx
        stx menupt2+1
        lda #<menutxt0
        ldx #>menutxt0
        sta datzp+0
        stx datzp+1
        lda #<(VRAM+(menuy-1)*rowlen+menux)
        ldx #>(VRAM+(menuy-1)*rowlen+menux)
        sta diszp+0
        stx diszp+1
        lda #<(CRAM+(menuy-1)*rowlen+menux)
        ldx #>(CRAM+(menuy-1)*rowlen+menux)
        sta colorzp+0
        stx colorzp+1
        ldx #0 ;menuheight
-       ldy #menuwidth-1
-       lda (datzp),y
menupt2 cpx #selfmod ;menupoint
        bne +
        ora #$80
+       sta (diszp),y
        lda #menufgcol
        cpx menupt2+1
        bne +
        lda #menuactivecol
+       sta (colorzp),y
        dey
        bpl -
        jsr nextrow
        lda #menuwidth
        jsr datzadd
        inx
        cpx #menuheight
        bne --
        rts


;---------------------------- menu data --------------------------------
.enc screen
menutxt
menutxt0 .text "TEDZAKKER ",VERSION," MENU"
menutxt0_end
menutx0b .text "------------------"
menutxt1 .text "1. LOAD WORKFILE  " ;"1. LOAD WORKF",(PLAYABLE_IMPORT_SUPPORT>0)? "/TUNE":"ILE  "
menutxt2 .text "2. SAVE WORKFILE  "
 .if (INSTRUMENT_LOADSAVE_SUPPORT>0)
menutxt3 .text "3. LOAD INSTRUMENT"
menutxt4 .text "4. SAVE INSTRUMENT"
 .fi
 .if (PLAYABLE_EXPORT_SUPPORT>0)
relocPl  .text "5. EXPORT TO $"
reloctxt .text               "0000"
zeropPl  .text "   ZEROPAGE: $"
zeroptxt .text               "00  "
 .fi
 .if (RUNNABLE_EXPORT_SUPPORT>0)
menutxt6 .text "6. EXPORT TED(TMF)" ;.text "6. EXPORT RUNNABLE"
;  .if (TMF_EXPORT_SUPPORT>0)
plytimtx .text "   PLAYTIME: 00:00" ;menutxt6b .text "   EXPORT TED(TMF)"
;  .fi
 .fi
drivePl  .text "7. DISK DRIVE: "
drivetxt .text                "00 "
menutxt8 .text "8. CLEAR PAT.&SEQ."
menutxt9 .text "9. CLEAR INSTRUM. "
ptlenPl  .text "A. SET PAT.LEN:$"
ptlentxt .text                 "00"
 .if (HERMIDI_SUPPORT>0)
miditxt  .text "B. HERMIDI-ACT.:"
midictxt .text                 "--"
 .fi
 .if (EXAMPLE_TUNE_SUPPORT>0)
menutxtB .text "C. EXAMPLE TUNE   "
 .fi
 .if (HELPTEXT_SUPPORT>0)
menutxtC .text "D. HELP/CHEATSHEET"
 .fi
menutxtD .text "E. EDITOR (F8/ESC)"
menutxt_end


playersize=explayer.player_bottom-explayer.player_top

 .if (HELPTEXT_SUPPORT>0)

MenuHelpTxt
.text "TOGGLE MENU WITH HELP(F8)/F7 KEY ANYTIME"
.text "CURSOR-UP/DOWN OR 1..E, THEN RETURN KEY,"
.text "PUSH +/- OR CURSOR-L/R TO ADJUST VALUES."
.text "IN THE EDITOR HOLD DOWN C=+H TO SEE HELP"
CreditTxt
.text "      2023 HERMIT SOFTWARE HUNGARY      "
.enc none

.enc screen
playername .text "NORMAL  ","MEDIUM  ","LIGHT   ","EXTRA   ","BARE    ","DEMO    "

featuretxt .text "MultiSpd","NoFrSkip","FS.VolFX","Pack.NOP","Subtunes","Subt.Jmp"
           .text "Ordrl.FX","Transpos","TempoPrg","Main-Vol"
           .text (MAIN_VOLUME_FADEOUT_SUPPORT==0)? "Ext.mVol" : "Ex.VFade"
           .text "Note-FX ","LowNotes","fBalance"
           .text "Portamen","Vibratos","Inc.Vibr","ViRestor","SmartVFX","Detuning"
           .text "Fr1Click","Fr1C.Vol","Tbl.Wait","NoteOFFi","Synching"," Phasing","Envelope","MixModes"
featuretxt_end
pltypetxt .text "PLAYER: "
plsizetxt .text "SIZE:$  "
pltimetxt .text "RTIME:$ "
.enc none

rastertime = PLAYERTYPE==0?$1E: PLAYERTYPE==1?$1C: PLAYERTYPE==2?$18: PLAYERTYPE==3?$24: PLAYERTYPE==4?$11: PLAYERTYPE==5?$17: 0


featinstances .byte MULTISPEED_ENTRY_SUPPORT ? "*" : " " ;$7A
              .byte FRAME_NOSKIP_SUPPORT ? "*" : " "   
              .byte FRAMESKIP_NOTEVOL_SUPPORT ? "*" : " "
              .byte PACKED_NOP_SUPPORT ? "*" : " "
              .byte SUBTUNE_SUPPORT ? "*" : " "
              .byte SUBTUNE_JUMP_SUPPORT ? "*" : " "
              .byte SEQ_FX_SUPPORT ? "*" : " "
              .byte TRANSPOSE_SUPPORT ? "*" : " "
              .byte TEMPOPROGRAM_SUPPORT ? "*" : " "
              .byte MAIN_VOLUME_SUPPORT ? "*" : " "
              .byte (EXT_MAIN_VOLUME_SUPPORT || MAIN_VOLUME_FADEOUT_SUPPORT) ? "*" : " "
              .byte NOTE_FX_SUPPORT ? "*" : " "
              .byte LOWFREQ_NOISELOOP_SUPPORT ? "*" : " "
              .byte BALANCED_SLIDE_SUPPORT ? "*" : " "

              .byte PORTAMENTO_SUPPORT ? "*" : " "
              .byte VIBRATO_SUPPORT ? "*" : " "
              .byte INCREMENTAL_VIBRATO_SUPPORT ? "*" : " "
              .byte VIBRATO_RESTORE_SUPPORT ? "*" : " "
              .byte GENTLE_VIBRATO_FX_SUPPORT ? "*" : " "
              .byte DETUNE_SUPPORT ? "*" : " "
              .byte SOUNDSTART_CLICK_SUPPORT ? "*" : " "    
              .byte STARTCLICK_VOL_SUPPORT ? "*" : " "
              .byte TABLE_DELAY_SUPPORT  ? "*" : " "
              .byte NOTEOFF_TBINDEX_SUPPORT ? "*" : " "
              .byte SYNC_SUPPORT ? "*" : " "
              .byte PHASE_SUPPORT ? "*" : " "
              .byte NOTEVOLUME_FADE_SUPPORT ? "*" : " "
              .byte MIXING_MODES_SUPPORT ? "*" : " "
 .fi ;end of HELPTXT_SUPPORT


menuPtKey .byte $38*2,$3B*2       ;keycodes 1..9 and A..F for menupoints
          .if (INSTRUMENT_LOADSAVE_SUPPORT>0)
            .byte $08*2,$0B*2
          .fi
          .if (PLAYABLE_EXPORT_SUPPORT>0)
            .byte $10*2
            .byte $10*2
          .fi
          .if (RUNNABLE_EXPORT_SUPPORT>0)
            .byte $13*2
           ;.if (TMF_EXPORT_SUPPORT>0)
             .byte $13*2
           ;.fi
          .fi
          .byte $18*2,$1B*2,$20*2, $0A*2
          .if (HERMIDI_SUPPORT>0)
           .byte $1C*2  
          .fi
          .if (EXAMPLE_TUNE_SUPPORT>0)          
           .byte $14*2
          .fi
          .if (HELPTEXT_SUPPORT>0)
           .byte $12*2
          .fi
          .byte $0E*2,$42*2,$29*2

menuPtAddr .word loadDialog,saveDialog
           .if (INSTRUMENT_LOADSAVE_SUPPORT>0)
            .word loadInsDialog,saveInsDialog
           .fi
           .if (PLAYABLE_EXPORT_SUPPORT>0)
            .word exportPlayableDialog
            .word exportPlayableDialog
           .fi
           .if (RUNNABLE_EXPORT_SUPPORT>0)
            .word exportRunnableDialog
            ;.if (TMF_EXPORT_SUPPORT>0)
             .word adjustPlayTime ;exportTMFdialog
            ;.fi
           .fi
           .word setDrive,clearTune,clearIns,setPattLen
           .if (HERMIDI_SUPPORT>0)
           .word setMIDI
           .fi
           .if (EXAMPLE_TUNE_SUPPORT>0)
            .word exampleTune
           .fi
           .if (HELPTEXT_SUPPORT>0)
            .word showHelp
           .fi 
           .word retuEdi

.else
menu    lda #exitmode_noexit
        sta exitsig
menustrt;sei
        jsr ROMdisa
        ;jsr stopply
        jsr player.silence
        ;lda #keymode_menu
        ;sta keyermode ;set already by menu-caller
        ;jsr waitkeyrelease

        jsr filmode
        jmp chexits

filmode lda #selfmod
        bne +
        jmp LoadDialog    ;0
+       cmp #2
        bcs +
        jmp SaveDialog    ;1
+
 .if (INSTRUMENT_LOADSAVE_SUPPORT>0)
        bne +
        jmp SaveDialog    ;2
+       jmp SaveInsDialog ;3
 .fi
.fi ;end of MENU_SUPPORT




;-------------------------------menupoints------------------------------
.if (FILEDIALOG_SUPPORT>0)
setTZWe	clc
        bit dpywmk0
        ldx #extlen-1	;set TEDzakker-Workfile extension
-       lda TZWext,x
		sta filedialog.tzftype+1,x
		dex
		bpl -
        rts

setTZIe ldx #extlen-1	;set TEDzakker-Instrument extension
-       lda TZIext,x
		sta filedialog.tzftype+1,x
		dex
		bpl - 
        rts
.fi


loadDialog 
        .if (FILEDIALOG_SUPPORT>0)
        jsr setTZWe
        lda #2
		sta filedialog.defawin+1	;file-selector is preferred default subwindow in loader-filer (but changeable with TAB)
		lda #0
		sta filedialog.editauth
        .fi
        jsr (FILEDIALOG_SUPPORT>0)? filedialog.reredir: filedialog.fdialog ;reading directory automatically for loader
        bcc +
goRetuM jmp returnM
+       jmp loadWorkfile ;goBackE


saveDialog 
        .if (INFOBAR_SUPPORT>0)
        jsr nofirst
        .fi
        .if (FILEDIALOG_SUPPORT>0)
        jsr setTZWe
        lda #1
		sta filedialog.editauth	;switch on author-editing for saver
        lda #0
		sta filedialog.defawin+1	;filename-input is preferred default subwindow in saver-filer (but changeable with TAB)
         ;.if (EMULATOR!=0)
         ; sta filedialog.not1st+1
         ;.fi
        .fi
        jsr filedialog.fdialog ;reredir ;directory loads only when F1 is pressed
        bcs goRetuM ;returnM
        jmp saveWorkfile


.if (INSTRUMENT_LOADSAVE_SUPPORT>0)
loadInsDialog
        .if (FILEDIALOG_SUPPORT>0)
        jsr setTZIe
        lda #2
		sta filedialog.defawin+1	;file-selector is preferred default subwindow in loader-filer (but changeable with TAB)
		lda #0
		sta filedialog.editauth
        .fi
        jsr filedialog.reredir ;reading directory automatically for loader
        bcs returnM
        jmp loadIns

saveInsDialog
        .if (FILEDIALOG_SUPPORT>0)
        jsr setTZIe
		lda #0
		sta filedialog.editauth	
        lda #0
		sta filedialog.defawin+1	;filename-input is preferred default subwindow in saver-filer (but changeable with TAB)
        .fi
        jsr filedialog.fdialog ;reredir ;directory loads only when F1 is pressed
        bcs returnM
        jmp saveIns
.fi


.if (PLAYABLE_EXPORT_SUPPORT>0)
exportPlayableDialog
        .if (FILEDIALOG_SUPPORT>0)
		ldx #extlen-1
-       lda PRGext,x   ;playable PRG format
		sta filedialog.tzftype+1,x
		dex
		bpl -
        lda #1
		sta filedialog.editauth	;switch on author-editing for saver
        lda #0
		sta filedialog.defawin+1	;filename-input is preferred default subwindow in saver-filer (but changeable with TAB)
        .fi
        jsr filedialog.fdialog ;reredir ;directory loads only when F1 is pressed
        bcs returnM
        jmp savePlayable
.fi


.if (RUNNABLE_EXPORT_SUPPORT>0)
exportRunnableDialog
        .if (FILEDIALOG_SUPPORT>0)
		ldx #extlen-1
-       lda RUNext,x   ;runnable format
		sta filedialog.tzftype+1,x
		dex
		bpl -
        lda #1
		sta filedialog.editauth	;switch on author-editing for saver
        lda #0
		sta filedialog.defawin+1	;filename-input is preferred default subwindow in saver-filer (but changeable with TAB)
        .fi
        jsr filedialog.fdialog ;reredir ;directory loads only when F1 is pressed
        bcs returnM
        jmp saveRunnable

; .if (TMF_EXPORT_SUPPORT>0)
adjustPlayTime
        jmp exportRunnableDialog
;exportTMFdialog
;        .if (FILEDIALOG_SUPPORT>0)
;		ldx #extlen-1
;-       lda TEDext,x   ;runnable format
;		sta filedialog.tzftype+1,x
;		dex
;		bpl -
;        lda #1
;		sta filedialog.editauth	;switch on author-editing for saver
;        lda #0
;		sta filedialog.defawin+1	;filename-input is preferred default subwindow in saver-filer (but changeable with TAB)
;        .fi
;        jsr filedialog.fdialog ;reredir ;directory loads only when F1 is pressed
;        bcs returnM
;        jmp saveRunnable
; .fi
.fi


returnM	jmp retMenu


.if TUNEINIT_SUPPORT
clearTune
		jsr RyouSur
		bcc returnM
.if (RUNNABLE_EXPORT_SUPPORT>0)
        jsr initPlayTimes
.fi
        lda #0
.if (RUNNABLE_EXPORT_SUPPORT>0)
        sta tuneheader.playtime0+0
        sta tuneheader.playtime0+1
.fi
        sta tuneheader.subtune_amount
        sta tuneheader.ptn_amount
        jsr depksub
        jsr depkptn
        ldy #authorinfo_len-1
-       lda #" "
        sta authorinfo,y
        dey
        bpl -
        ldy #1
        sty currptn+0
        sty player.currpatt+0
        iny ;2 
        sty currptn+1
        sty player.currpatt+1
        jmp restTun


clearIns
		jsr RyouSur
		bcc returnM
        lda #0
        sta tuneheader.ins_amount
        jsr depkins
        jmp restIns       


setPattLen
		jsr RyouSur
		bcc returnM
        ldy #maxptnamount
-       lda tuneheader.defaultptlen
        sta ptnlen,y
        dey
        bpl -
reseptn ldx #CHANNELAMOUNT-1
-       lda ptnindex,x
        cmp tuneheader.defaultptlen
        bcc +
        lda #0
        sta ptnindex,x
        sta curwinposy+ptnwin
+       dex
        bpl -
        jmp restTun
.fi


.if (HELPTEXT_SUPPORT>0)
ShowHelp
        php ;store I-flag
        ;sei
        jsr ROMdisa
        jsr hidecursor
        jsr player.silence
        lda #$1b ;not extended-colour mode
        sta vmodeyscroll
        lda #helpbgcol
        sta bgcol
        sta bordcol
        jsr smallch
 .if(MACHINE==2)
        lda #$34
        sta banksel ;grab helptext from under I/O area
 .fi
        ldy #0
-       lda helptxt,y
		;cmp #$60		;input: Accu, output: Accu
		;bcc +			;handle lowercase
		;and #$1f
+       sta VRAM,y
        lda helptxt+$100,y
        sta VRAM+$100,y
        lda helptxt+$200,y
        sta VRAM+$200,y
        lda helptxt+$300,y
        sta VRAM+$300,y
        iny
        bne -
 .if(MACHINE==2)
        lda #$35
        sta banksel
 .fi
        lda #helpfgcol
        ldy #0
-       sta CRAM,y
        sta CRAM+$100,y
        sta CRAM+$200,y
        sta CRAM+$300,y
        iny
        bne -
        jsr waitkeyrelease 
        lda keyermode
        cmp #keymode_menu
        bne +
        jsr waitkeypress
+       plp ;restore I-flag
        jmp returnM
.fi ;end of HELPTEXT_SUPPORT


.if (EXAMPLE_TUNE_SUPPORT>0)
exampleTune
		jsr RyouSur
        bcs +
		jmp returnM
+       lda #<demotune
        ldx #>demotune
        sta demotpt+1
        stx demotpt+2
        lda #<tuneheader
        ldx #>tuneheader
        sta targtpt+1
        stx targtpt+2
 .if (MACHINE==2)
        lda #$34
        sta banksel ;get demotune from under I/O area
 .fi
demotpt lda selfmodA
targtpt sta selfmodA
        inc targtpt+1
        bne +
        inc targtpt+2
+       inc demotpt+1
        bne +
        inc demotpt+2
+       lda demotpt+1
        cmp #<demotune_end
        bne demotpt
+       lda demotpt+2
        cmp #>demotune_end
        bne demotpt
 .if (MACHINE==2)
        lda #$35
        sta banksel
 .fi
 .if (RUNNABLE_EXPORT_SUPPORT>0)
        jsr initPlayTimes
 .fi
        lda targtpt+1
        sta tuneendptr+0
        lda targtpt+2
        sta tuneendptr+1
        jsr depackworkfile
        jsr nofirst
        jmp restEdi
.fi
