
;========================== TUNE DEPACKER ==============================

depackworkfile
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
        lda #packmode_workfile
depacktune ;'tuneendptr' must be set to 1st byte after packed/loaded tune-data
        sta depkmod+1
.fi
        lda tuneendptr+0
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
depkmod ldy #selfmod ;0:workfile 1:playable tune
        ;cpy #packmode_workfile
        beq + 
        sta compzp+0
        lda tuneendptr+1
        sta compzp+1
        jmp dpkrest ;loader should be able to read and copy the autor-info from players      
.fi
+       sec
        sbc #authorinfo_len
        sta compzp+0
        lda tuneendptr+1
        sbc #0 ;subtract Carry
        sta compzp+1
getauth ldy #authorinfo_len-1
-       lda (compzp),y
        sta authorinfo,y
        dey
        bpl -        
    
dpkrest jsr depttmp
        jsr depkptn
        jsr depkins
        jsr depksub

        rts


;--------------------------------- depack temporary pointers to their place
depttmp ldy tuneheader.ptn_amount
        jsr compsb2
-       cpy #maxptnamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta ptniftmp,y
+       dey
        bpl -
        ldy tuneheader.ptn_amount
        jsr compsb2
-       cpy #maxptnamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta ptniitmp,y
+       dey
        bpl -
        ldy tuneheader.ptn_amount
        jsr compsb2
-       cpy #maxptnamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta ptnphtmp,y
+       dey
        bpl -
        ldy tuneheader.ptn_amount
        jsr compsb2
-       cpy #maxptnamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta ptnpltmp,y
+       dey
        bpl -
        ldy tuneheader.ins_amount
        jsr compsb2
-       cpy #maxinstamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta insphtmp,y
+       dey
        bpl -
        ldy tuneheader.ins_amount
        jsr compsb2
-       cpy #maxinstamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta inspltmp,y
+       dey
        bpl -
        ldy tuneheader.subtune_amount
        jsr compsub
-       cpy #maxsubtuneamount ;+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta seqph2tmp,y
+       dey
        bpl -
        ldy tuneheader.subtune_amount
        jsr compsub
-       cpy #maxsubtuneamount ;+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta seqph1tmp,y
+       dey
        bpl -
        ldy tuneheader.subtune_amount
        jsr compsub
-       cpy #maxsubtuneamount ;+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta seqpl2tmp,y
+       dey
        bpl -
        ldy tuneheader.subtune_amount
        jsr compsub
-       cpy #maxsubtuneamount ;+1 ;omit pointers not fitting into current editor
        bcs +
        lda (compzp),y
        sta seqpl1tmp,y
+       dey
        bpl -

;correct pointers by the difference to original save-address of loaded tune
        lda #<tuneheader  
        sec
        sbc tuneheader.baseaddress+0
        sta basediff+0
        lda #>tuneheader
        sbc tuneheader.baseaddress+1
        sta basediff+1
corrsub ldy tuneheader.subtune_amount
-       cpy #maxsubtuneamount ;+1 ;omit pointers not fitting into current editor
        bcs +
        lda seqpl1tmp,y
        clc
        adc basediff+0
        sta seqpl1tmp,y
        lda seqph1tmp,y
        adc basediff+1
        sta seqph1tmp,y
        lda seqpl2tmp,y
        clc
        adc basediff+0
        sta seqpl2tmp,y
        lda seqph2tmp,y
        adc basediff+1
        sta seqph2tmp,y
+       dey
        bpl -
corrins ldy tuneheader.ins_amount
-       cpy #maxinstamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda inspltmp,y
        clc
        adc basediff+0
        sta inspltmp,y
        lda insphtmp,y
        adc basediff+1
        sta insphtmp,y
+       dey
        bpl -
corrptn ldy tuneheader.ptn_amount
-       cpy #maxptnamount+1 ;omit pointers not fitting into current editor
        bcs +
        lda ptnpltmp,y
        clc
        adc basediff+0
        sta ptnpltmp,y
        lda ptnphtmp,y
        adc basediff+1
        sta ptnphtmp,y
+       dey
        bpl -
        lda #<tuneheader
        ldx #>tuneheader
        sta tuneheader.baseaddress+0
        stx tuneheader.baseaddress+1
        rts

compsb1 tay
compsb2 iny
compsub sty ystore3+1
        lda compzp+0
        sec
ystore3 sbc #selfmod
        sta compzp+0
        bcs +
        dec compzp+1
+       rts


;------------------------ depack/init patterns
;(as they contain $FF at the end, pointers are not quite necessary to depack'em, but safer)
depkptn ldx #maxptnamount ;compzp must point right after the last patterns last byte
deptnlp lda pattptlo,x
        sta datzp+0
        lda pattpthi,x
        sta datzp+1
        cpx tuneheader.ptn_amount
        beq dpkpatt
        bcs initptn
dpkpatt lda compzp+0
        sec
        sbc ptnpltmp,x
        sec
        sbc ptniftmp,x
        tay
        jsr compsub
        lda fxindexes,x
        jsr dptcolu
        lda ptniftmp,x
        sec
        sbc ptniitmp,x
        tay
        jsr compsub
        lda insindexes,x
        jsr dptcolu
        lda ptnpltmp,x
        sta compzp+0
        lda ptnphtmp,x
        sta compzp+1
        lda #0
        jsr dptcolu
        jmp dnextpt
initptn ldy #0
-       lda #0
        sta (datzp),y
        iny
        cpy #(maxptnlen+1)*3
        bne -
        lda tuneheader.defaultptlen
        sta ptnlen,x
dnextpt dex
        bne deptnlp
        rts
dptcolu ;depacks a pattern-column, including packed NOPs to 'datzp' target address
        stx xstore8+1
        clc
        adc datzp+0
        sta dptargt+1
        lda datzp+1
        adc #0 ;add Carry
        sta dptargt+2
        ldx #0
        stx packcnt
        ldy #0 
-       lda packcnt
        bne wrPkNOP        
        lda (compzp),y 
        iny
        cmp #packNOP_min
        bcc dptargt
        cmp #ptnendval
        beq regplen
depkNOP sec
        sbc #packNOP_min-2
        sta packcnt
wrPkNOP dec packcnt
        lda #0
dptargt sta selfmodA,x
        inx
        bne - ;jmp
regplen txa
xstore8 ldx #selfmod
        sta ptnlen,x
        rts


;------------------------- depack/init instruments
depkins 
.if (PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0)
        lda #<(insnametemp-insnamepos + (maxinstamount-1)*insnamelen)
        ldx #>(insnametemp-insnamepos + (maxinstamount-1)*insnamelen)
        sta inametmptr+0
        stx inametmptr+1
.fi
        ldx #maxinstamount
dpinslp lda insptlo,x
        sta datzp+0
        lda inspthi,x
        sta datzp+1
        cpx tuneheader.ins_amount
        beq dpkinst
        bcs initins
dpkinst lda insphtmp,x
        beq initins ;if packed instrument has zero pointer, init it instead
        sta compzp+1
        lda compzp+0 ;depack loaded instruments
        sec
        sbc inspltmp,x
        sta inssize
        lda inspltmp,x
        sta compzp+0
        jsr dp1inst
        jmp dpnexti
initins ldy #0 ;init instruments above the last loaded instrument
-       lda emptyins,y
        sta (datzp),y
        iny
        cpy #ins_maxsize
        bne -
dpnexti 
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
        lda inametmptr+0
        sec
        sbc #insnamelen
        sta inametmptr+0
        bcs +
        dec inametmptr+1
.fi
+       dex
        bne dpinslp
retidpk rts

depack1inst
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
        lda #packmode_workfile ;depack 1 instrument, compzp and datzp are set as base, X holds number of instrument, set inssize!
        sta depkmod+1
.fi
dp1inst ;depack 1 instrument, compzp and datzp are set as base, X holds number of instrument, set dpkmod and inssize!
insthdr ldy #insheadersize-1 ;inst.header-length
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
        lda depkmod+1
        ;cmp #packmode_workfile
        beq dpkihdr
        ldy #insheadersize-1
-       lda (inametmptr),y
        sta (datzp),y
        dey
        cpy #insmaindatalen-1
        bne -
        ldy #insmaindatalen-1
.fi
dpkihdr lda (compzp),y ;depack instrument-header
        sta (datzp),y
        dey
        bpl dpkihdr
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
cwfgoff lda depkmod+1
        ;cmp #packmode_workfile
        beq cfrgoff
        ldy #wftbnoteoffindexpos ;correct gateoff-pointers
        lda (compzp),y
        beq cfrgoff ;if zero, nothing to correct
        clc
        adc #insheadersize-insmaindatalen
        sta (datzp),y
.fi
cfrgoff ldy #freqtbstartindexpos
        lda (compzp),y
        sta dpfrqtb+1
        lda #wftbstartindex+maxinstblen+1 ;correct for editor
        sta (datzp),y
        sec
        sbc (compzp),y
        sta cfrgdif+1
        ldy #freqtbnoteoffindexpos
        lda (compzp),y
        beq cvogoff ;if zero, nothing to correct
        clc
cfrgdif adc #selfmod
        sta (datzp),y
cvogoff ldy #voltbstartindexpos
        lda (compzp),y
        sta dpvoltb+1
        lda #wftbstartindex+(maxinstblen+1)*2 ;correct for editor
        sta (datzp),y
        sec
        sbc (compzp),y
        sta cvogdif+1
        ldy #voltbnoteoffindexpos
        lda (compzp),y
        beq dpvoltb ;if zero, nothing to correct
        clc
cvogdif adc #selfmod
        sta (datzp),y
;should start with last table (in-place decompression! after all)
dpvoltb lda #selfmod ;depack volume-table
        sta tblstrt+1
        jsr adtmpz2
        lda inssize
        sec
        sbc dpvoltb+1
        tay
        lda #wftbstartindex+(maxinstblen+1)*2
        jsr dptbcol
dpfrqtb lda #selfmod ;depack freq.table
        sta tblstrt+1
        jsr adtmpz2
        lda dpvoltb+1
        sec
        sbc dpfrqtb+1
        tay
        lda #wftbstartindex+maxinstblen+1
        jsr dptbcol
dpwftbl lda #wftbstartindex ;depack WF-table
.if ( PLAYABLE_EXPORT_SUPPORT>0 || RUNNABLE_EXPORT_SUPPORT>0 ) ;|| PLAYABLE_IMPORT_SUPPORT>0 )
        ldy depkmod+1
        ;cmp #packmode_workfile
        beq +
        lda #insmaindatalen
.fi
+       sta tblstrt+1
        jsr adtmpz2
        lda dpfrqtb+1
        sec
        sbc tblstrt+1 ;#wftbstartindex
        tay
        lda #wftbstartindex
;        jsr dptbcol
;        rts
dptbcol sty itbleng+1 ;depack a table-column (tempzp:source-tablebase,datzp:target-tablebase)
        clc
        adc insptlo,x
        sta datzp+0
        lda inspthi,x
        adc #0 ;Add Carry
        sta datzp+1
        ldy #maxinstblen-1
-       lda (tempzp),y
itbleng cpy #selfmod
        bcs +
        cmp #jumpval
        bne wriitbl
        sta (datzp),y
        iny
        lda (datzp),y
        sec
tblstrt sbc #selfmod
        sta (datzp),y
        dey
        jmp nxtbrow
+       lda #0
wriitbl sta (datzp),y
nxtbrow dey
        bpl -
        rts


;---------------------- depack subtune-orderlists (sequences)
depksub ;'compzp' should point right after subtunes' data at entry
        ldx #maxsubtuneamount-1
dpsublp lda seqptrlo+maxsubtuneamount,x
        sta datzp+0
        lda seqptrhi+maxsubtuneamount,x
        sta datzp+1
        cpx tuneheader.subtune_amount
        bcc dpksubt
inisubt ldy #0
-       lda #0
        sta (datzp),y        
        iny
        cpy #maxseqlen+1
        bne -
        jmp dpsubl1 ;dpnexts
dpksubt lda seqph2tmp,x
        beq inisubt ;zero-pointers should be skipped
        sta compzp+1
        lda compzp+0
        sec
        sbc seqpl2tmp,x
        sta seq2len+1
        lda seqpl2tmp,x
        sta compzp+0
        ldy #maxseqlen
-       lda (compzp),y
seq2len cpy #selfmod
        bcc +       
        lda #0 ;clean the rest of the sequence
+       sta (datzp),y
        dey
        bpl -

dpsubl1 lda seqptrlo,x
        sta datzp+0
        lda seqptrhi,x
        sta datzp+1
        cpx tuneheader.subtune_amount
        bcc dpksub1
inisub1 ldy #0
-       lda #0
        sta (datzp),y        
        iny
        cpy #maxseqlen+1
        bne -
        jmp dpnexts
dpksub1 lda seqph1tmp,x
        beq inisub1 ;zero-pointers should be skipped
        sta compzp+1
        lda seqpl1tmp,x
        sta compzp+0
        lda seqpl2tmp,x
        sec
        sbc seqpl1tmp,x
        sta seq1len+1
        ldy #maxseqlen
-       lda (compzp),y
seq1len cpy #selfmod
        bcc +
        lda #0 ;clean the rest of the sequence
+       sta (datzp),y
        dey
        bpl -        
dpnexts dex
        bmi +
        jmp dpsublp
+       rts

